Get Started with ag-Grid in Your Project

The "ag" part of ag-Grid stands for "agnostic". The internal ag-Grid engine is implemented in plain JavaScript[1] and has zero dependencies. If your project does not use one of the JavaScript frameworks that ag-Grid supports, or you are curious to understand how the grid works in its pure form, this guide is for you!

In this article, we will walk you through the necessary steps to add ag-Grid to an existing JavaScript project, and configure some of the essential features of it. We will show you some of the fundamentals of the grid (passing properties, using the API, etc).

The Project Setup

During the last couple of years, we are witnessing a Cambrian Explosion of JavaScript project stacks. It seems like everyday there is a new, better way for JavaScript developers to build and distribute their apps. However, for the purposes of this setup, we are going to stick to tried-and-true no-build, single HTML file setup which loads the ag-Grid scripts from CDN (our favorite one is unpkg). Let's start from this clean html file:

<!DOCTYPE html> <html> <head> </head> <body> <h1>Hello from ag-grid!</h1> </body> </html>
You can either use your favorite programming text editor, or you can execute the steps in the tutorial using this Plunker as a starting point.

Add ag-Grid to Your Project

We are going to load the necessary scripts and styles from the unpkg CDN. Add the following to the head element:

<!DOCTYPE html> <html> <head> <script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script> <link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css"> <link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-balham.css"> </head> <body> <h1>Hello from ag-grid!</h1> </body> </html>

The lines above import the AgGrid component, the grid "structure" stylesheet (ag-grid.css), and one of the available grid themes: (ag-theme-balham.css). The grid ships several different themes; pick one that matches your project design.

Now, let's instantiate a grid!

<!DOCTYPE html> <html> <head> <script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script> <link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css"> <link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-balham.css"> </head> <body> <h1>Hello from ag-grid!</h1> <div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-balham"></div> <script type="text/javascript" charset="utf-8"> // specify the columns var columnDefs = [ {headerName: "Make", field: "make"}, {headerName: "Model", field: "model"}, {headerName: "Price", field: "price"} ]; // specify the data var rowData = [ {make: "Toyota", model: "Celica", price: 35000}, {make: "Ford", model: "Mondeo", price: 32000}, {make: "Porsche", model: "Boxter", price: 72000} ]; // let the grid know which columns and what data to use var gridOptions = { columnDefs: columnDefs, rowData: rowData }; // lookup the container we want the Grid to use var eGridDiv = document.querySelector('#myGrid'); // create the grid passing in the div to use together with the columns & data we want to use new agGrid.Grid(eGridDiv, gridOptions); </script> </body> </html>

The variables above present two essential configuration properties of the grid - the column definitions (columnDefs) and the data (rowData). In our case, the column definitions contain three columns; each column entry specifies the header label and the data field to be displayed in the body of the table.

The actual data is defined in the rowData as an array of objects. Notice that the fields of the objects match the field values in the columnDefs configuration object.

Finally, the DIV element is the DOM entry point of the grid. It sets the grid dimensions and specifies the grid's theme by setting the class to ag-theme-balham. As you may have already noticed, the CSS class matches the name of CSS file we imported earlier.

ag-Grid in its simplest form

Enable Sorting And Filtering

So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the least/most expensive? Well, enabling sorting in ag-Grid is actually quite simple - all you need to do is add sortable to each column.

var columnDefs = [ {headerName: "Make", field: "make", sortable=true }, {headerName: "Model", field: "model", sortable=true }, {headerName: "Price", field: "price", sortable=true } ];

After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.

Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) or rows, with many columns. In a data set like this filtering is your friend.

As with sorting, enabling filtering is as easy as adding the filter property:

var columnDefs = [ {headerName: "Make", field: "make", sortable=true, filter=true }, {headerName: "Model", field: "model", sortable=true, filter=true }, {headerName: "Price", field: "price", sortable=true, filter=true } ];

With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with filtering UI which lets you choose the kind of filter and the text that you want to filter by.

ag-Grid sorting and filtering

Fetch Remote Data

Displaying hard-coded data in JavaScript is not going to get us very far. In the real world, most of the time, we are dealing with data that resides on a remote server. Nowadays, implementing this is actually quite simple. Notice that the actual data fetching is performed outside of the grid component - We are using the HTML5 fetch API.

If you have to support older browsers but you want to use fetch, you can add the respective polyfill.
<!DOCTYPE html> <html> <head> <script src="https://unpkg.com/ag-grid-community/dist/ag-grid-community.min.noStyle.js"></script> <link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css"> <link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-balham.css"> </head> <body> <h1>Hello from ag-grid!</h1> <div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-balham"></div> <script type="text/javascript" charset="utf-8"> // specify the columns var columnDefs = [ {headerName: "Make", field: "make"}, {headerName: "Model", field: "model"}, {headerName: "Price", field: "price"} ]; // let the grid know which columns to use var gridOptions = { columnDefs: columnDefs }; // lookup the container we want the Grid to use var eGridDiv = document.querySelector('#myGrid'); // create the grid passing in the div to use together with the columns & data we want to use new agGrid.Grid(eGridDiv, gridOptions); fetch('https://api.myjson.com/bins/ly7d1').then(function(response) { return response.json(); }).then(function(data) { gridOptions.api.setRowData(data); }) </script> </body> </html>

Here, we replaced the rowData assignment with a data fetch from a remote service. The remote data is the same as the one we initially had, so you should not notice any actual changes to the grid.

Notice that we also did something new - we accessed the grid Api instance through the gridOptions.api. The api object exposes plethora of methods that allow us to implement complex scenarios with the grid.

Enable Selection

Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements! It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system. We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.

Fortunately, the above task is quite simple with ag-Grid. As you may have already guessed, it is just a matter of adding and changing couple of properties:

// specify the columns var columnDefs = [ {headerName: "Make", field: "make", checkboxSelection: true }, {headerName: "Model", field: "model"}, {headerName: "Price", field: "price"} ]; // let the grid know which columns and what data to use var gridOptions = { columnDefs: columnDefs, rowSelection: 'multiple' };

Great! Now the first column contains a checkbox that, when clicked, selects the row. The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we need the following change:

<button onclick="getSelectedRows()">Get Selected Rows</button> <div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-balham"></div> function getSelectedRows() { var selectedNodes = gridOptions.api.getSelectedNodes() var selectedData = selectedNodes.map( function(node) { return node.data }) var selectedDataStringPresentation = selectedData.map( function(node) { return node.make + ' ' + node.model }).join(', ') alert('Selected nodes: ' + selectedDataStringPresentation); }

Well, we cheated a bit. Calling alert is not exactly a call to our backend. Hopefully you will forgive us this shortcut for the sake of keeping the article short and simple. Of course, you can substitute that bit with a real-world application logic after you are done with the tutorial.

What happened above? Several things:

  • We added a button with an event handler;
  • Inside the event handler, we accessed the grid API to get the currently selected grid row nodes;
  • Afterwards, we extracted the row nodes' underlying data items and converted them to a string suitable to be presented to the user in an alert box.

Grouping (enterprise)

Grouping is a feature exclusive to the enterprise version of ag-Grid.

In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data. In our case, the data is not that much. Let's switch to a slightly larger data set:

- fetch('https://api.myjson.com/bins/ly7d1') + fetch('https://api.myjson.com/bins/15psn9')

Now, let's use ag-grid-enterprise! Replace the ag-grid script reference in the head with this one:

<script src="https://unpkg.com/ag-grid-enterprise/dist/ag-grid-enterprise.min.noStyle.js"></script>

If everything is ok, you should see a message in the console that warns you about missing enterprise license. In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup - feel free to look around:

ag-Grid final

Now, let's enable grouping! Change the configuration to this:

var columnDefs = [ {headerName: "Make", field: "make", rowGroup: true }, {headerName: "Price", field: "price"} ]; var autoGroupColumnDef = { headerName: "Model", field: "model", cellRenderer:'agGroupCellRenderer', cellRendererParams: { checkbox: true } } // let the grid know which columns and what data to use var gridOptions = { columnDefs: columnDefs, autoGroupColumnDef: autoGroupColumnDef, groupSelectsChildren: true, rowSelection: 'multiple' };

There we go! The grid now groups the data by make, while listing the model field value when expanded. Notice that grouping works with checkboxes as well - the groupSelectsChildren property adds a group-level checkbox that selects/deselects all items in the group.

Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.

This is how the final code should look:

<!DOCTYPE html> <html> <head> <script src="https://unpkg.com/ag-grid-enterprise/dist/ag-grid-enterprise.min.noStyle.js"></script> <link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-grid.css"> <link rel="stylesheet" href="https://unpkg.com/ag-grid-community/dist/styles/ag-theme-balham.css"> </head> <body> <h1>Hello from ag-grid!</h1> <button onclick="getSelectedRows()">Get Selected Rows</button> <div id="myGrid" style="height: 600px;width:500px;" class="ag-theme-balham"></div> <script type="text/javascript" charset="utf-8"> // specify the columns var columnDefs = [ {headerName: "Make", field: "make", rowGroup: true }, {headerName: "Price", field: "price"} ]; var autoGroupColumnDef = { headerName: "Model", field: "model", cellRenderer:'agGroupCellRenderer', cellRendererParams: { checkbox: true } } // let the grid know which columns and what data to use var gridOptions = { columnDefs: columnDefs, autoGroupColumnDef: autoGroupColumnDef, groupSelectsChildren: true, rowSelection: 'multiple' }; // lookup the container we want the Grid to use var eGridDiv = document.querySelector('#myGrid'); // create the grid passing in the div to use together with the columns & data we want to use new agGrid.Grid(eGridDiv, gridOptions); fetch('https://api.myjson.com/bins/15psn9').then(function(response) { return response.json(); }).then(function(data) { gridOptions.api.setRowData(data); }) function getSelectedRows() { const selectedNodes = gridOptions.api.getSelectedNodes() const selectedData = selectedNodes.map( function(node) { return node.data }) const selectedDataStringPresentation = selectedData.map( function(node) { return node.make + ' ' + node.model }).join(', ') alert('Selected nodes: ' + selectedDataStringPresentation); } </script> </body> </html>

Summary

With this Javascript datagrid tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping! While doing so, we learned how to configure the grid and how how to use its api object to call methods.

That's just scratching the surface, though. The grid has a lot more features to offer; the abilities to customize cells and headers with custom components allow for almost infinite possible configurations.

Next Steps

The best thing you can check after the Javascript grid tutorial is the features overview. It provides an extensive review of what you can achieve with ag-Grid. In addition, you can go through the following help articles to learn more about the features we enabled:

Sorting Filtering Grouping Selection

1 This is not exactly true. ag-Grid's core, as well as the framework wrappers are written in TypeScript. This provides nice strong typing and compile-time checks for our TypeScript users, while not giving the Babel/Vanilla users any disadvantage. ↩

Get Started with ag-Grid in Your Vue Project

The "ag" part of ag-Grid stands for "agnostic". The internal ag-Grid engine is implemented in TypeScript with zero dependencies. ag-Grid supports Vue through a wrapper component. The wrapper lets you use ag-Grid in your application like any other Vue component – you pass configuration through property bindings and handle events through event bindings. You can even use Vue components to customize the grid UI and cell contents / behavior.

In this article, we will walk you through the necessary steps to add ag-Grid to an existing Vue project, and configure some of the essential features of it. We will show you some of the fundamentals of the grid (passing properties, using the API, etc). As a bonus, we will also tweak the grid's visual appearance using Sass variables.

Add ag-Grid to Your Project

For the purposes of this tutorial, we are going to scaffold an Vue app with angular CLI. Don't worry if your project has a different configuration. Ag-Grid and its Vue wrapper are distributed as NPM packages, which should work with any common Vue project module bundler setup. Let's follow the Vue CLI instructions - run the following in your terminal:

npm install -g @vue/cli vue create my-project

When prompted choose "Manually select features":

Manually Select Features

Next, select Babel and CSS Pre-processors (we've also deselected Linter here, but this is optional):

Select Features

Next select SASS/SCSS as the CSS Pre-processor:

CSS Pre-processor

Finally choose where to store the configuration data - we've opted for dedicated config files:

Config files

We're not ready to start our application:

cd my-project npm run serve

If everything goes well, npm run serve has started the web server. You can open the default app at localhost:8080.

As a next step, let's add the ag-Grid NPM packages. run the following command in my-project (you may need a new instance of the terminal):

npm install --save ag-grid-community ag-grid-vue vue-property-decorator

After a few seconds of waiting, you should be good to go. Let's get to the actual coding! As a first step, let's add the ag-Grid the ag-Grid styles - import them in the style section of src/App.vue:

<style lang="scss"> @import "~ag-grid-community/dist/styles/ag-grid.css"; @import "~ag-grid-community/dist/styles/ag-theme-balham.css"; </style>

The code above imports the grid "structure" stylesheet (ag-grid.css), and one of the available grid themes: (ag-theme-balham.css). The grid ships several different themes; pick one that matches your project design.

In a later section we documentation on how you can Customise the Theme Look using SCSS, which is our recommended approach.

As this will be a simple example we can delete the src/components directory. Our example application will live in src/App.vue.

Let's add the component definition to our template. Edit app/App.vue and replace the scaffold code:

<template> <ag-grid-vue style="width: 500px; height: 500px;" class="ag-theme-balham" :columnDefs="columnDefs" :rowData="rowData"> </ag-grid-vue> </template>

Next, let's declare the basic grid configuration. Edit src/App.vue:

<script> import {AgGridVue} from "ag-grid-vue"; export default { name: 'App', data() { return { columnDefs: null, rowData: null } }, components: { AgGridVue }, beforeMount() { this.columnDefs = [ {headerName: 'Make', field: 'make'}, {headerName: 'Model', field: 'model'}, {headerName: 'Price', field: 'price'} ]; this.rowData = [ {make: 'Toyota', model: 'Celica', price: 35000}, {make: 'Ford', model: 'Mondeo', price: 32000}, {make: 'Porsche', model: 'Boxter', price: 72000} ]; } } </script>

The code above presents two essential configuration properties of the grid - the column definitions (columnDefs) and the data (rowData). In our case, the column definitions contain three columns; each column entry specifies the header label and the data field to be displayed in the body of the table.

This is the ag-grid component definition, with two property bindings - rowData and columnDefs. The component also accepts the standard DOM style and class. We have set the class to ag-theme-balham, which defines the grid theme. As you may have already noticed, the CSS class matches the name of CSS file we imported earlier.

Finally, note that we've imported the ag-grid-vue component - this is actual component that will provide the ag-Grid functionality.

If everything works as expected, you should see a simple grid like the one on the screenshot:

ag-Grid hello world

Enable Sorting And Filtering

So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the least/most expensive? Well, enabling sorting in ag-Grid is actually quite simple - all you need to do is set the sortable property to the column definitions.

this.columnDefs = [ {headerName: 'Make', field: 'make', sortable: true }, {headerName: 'Model', field: 'model', sortable: true }, {headerName: 'Price', field: 'price', sortable: true } ];

After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.

Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) or rows, with many columns. In a data set like this filtering is your friend.

As with sorting, enabling filtering is as easy as setting the filter property:

this.columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true }, {headerName: 'Model', field: 'model', sortable: true, filter: true }, {headerName: 'Price', field: 'price', sortable: true, filter: true } ];

With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with filtering UI which lets you choose the kind of filter and the text that you want to filter by.

ag-Grid sorting and filtering

Fetch Remote Data

Displaying hard-coded data in JavaScript is not going to get us very far. In the real world, most of the time, we are dealing with data that resides on a remote server. Thanks to React, implementing this is actually quite simple. Notice that the actual data fetching is performed outside of the grid component - We are using the HTML5 fetch API.

Now, let's remove the hard-coded data and fetch one from a remote server. Edit the src/App.vue and add the following fetch statement:

beforeMount() { this.columnDefs = [ {headerName: 'Make', field: 'make'}, {headerName: 'Model', field: 'model'}, {headerName: 'Price', field: 'price'} ]; fetch('https://api.myjson.com/bins/15psn9') .then(result => result.json()) .then(rowData => this.rowData = rowData); }

The remote data is the same as the one we initially had, so you should not notice any actual changes to the grid. However, you will see an additional HTTP request performed if you open your developer tools.

Enable Selection

Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements! It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system. We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.

Fortunately, the above task is quite simple with ag-Grid. As you may have already guessed, it is just a matter of adding and changing couple of properties.

<template> <ag-grid-vue style="width: 500px; height: 500px;" class="ag-theme-balham" :columnDefs="columnDefs" :rowData="rowData" rowSelection="multiple"> </ag-grid-vue> </template> <script> import {AgGridVue} from "ag-grid-vue"; export default { name: 'App', data() { return { columnDefs: null, rowData: null } }, components: { AgGridVue }, beforeMount() { this.columnDefs = [ {headerName: 'Make', field: 'make', checkboxSelection: true}, {headerName: 'Model', field: 'model'}, {headerName: 'Price', field: 'price'} ]; fetch('https://api.myjson.com/bins/15psn9') .then(result => result.json()) .then(rowData => this.rowData = rowData); } } </script> <style> </style>

Next, let's enable multiple row selection, so that the user can pick many rows:

<ag-grid-vue style="width: 500px; height: 500px;" class="ag-theme-balham" :columnDefs="columnDefs" :rowData="rowData" rowSelection="multiple"> </ag-grid-vue>

We've added a checkbox to the make column with checkboxSelection: true and then enabled multiple row selection with rowSelection="multiple".

We took a bit of a shortcut here, by not binding the property value. Without [], the assignment will pass the attribute value as a string, which is fine for our purposes.

Great! Now the first column contains a checkbox that, when clicked, selects the row. The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we are going to use the ag-Grid API - we will store a reference to both the grid and column API's in the gridReady event

To test this we'll add a button that gets the selected data and sends it to the server. Let's go ahead and make these changes:

<template> <div> <button @click="getSelectedRows()">Get Selected Rows</button> <ag-grid-vue style="width: 500px; height: 500px;" class="ag-theme-balham" :columnDefs="columnDefs" :rowData="rowData" rowSelection="multiple" :gridReady="onGridReady"> </ag-grid-vue> </div> </template> <script> import {AgGridVue} from "ag-grid-vue"; export default { name: 'App', data() { return { columnDefs: null, rowData: null } }, components: { AgGridVue }, methods: { onGridReady(params) { this.gridApi = params.api; this.columnApi = params.columnApi; }, getSelectedRows() { const selectedNodes = this.gridApi.getSelectedNodes(); const selectedData = selectedNodes.map( node => node.data ); const selectedDataStringPresentation = selectedData.map( node => node.make + ' ' + node.model).join(', '); alert(`Selected nodes: ${selectedDataStringPresentation}`); } }, beforeMount() { this.columnDefs = [ {headerName: 'Make', field: 'make', checkboxSelection: true}, {headerName: 'Model', field: 'model'}, {headerName: 'Price', field: 'price'} ]; fetch('https://api.myjson.com/bins/15psn9') .then(result => result.json()) .then(rowData => this.rowData = rowData); } } </script> <style> </style>

Well, we cheated a bit. Calling alert is not exactly a call to our backend. Hopefully you will forgive us this shortcut for the sake of keeping the article short and simple. Of course, you can substitute that bit with a real-world application logic after you are done with the tutorial.

Grouping (enterprise)

Grouping is a feature exclusive to the enterprise version of ag-Grid.

In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data. In our case, the data is not that much. Let's switch to a slightly larger data set:

beforeMount() { this.columnDefs = [ {headerName: 'Make', field: 'make', checkboxSelection: true}, {headerName: 'Model', field: 'model'}, {headerName: 'Price', field: 'price'} ]; - fetch('https://api.myjson.com/bins/15psn9') - .then(result => result.json()) - .then(rowData => this.rowData = rowData); + fetch('https://api.myjson.com/bins/ly7d1') + .then(result => result.json()) + .then(rowData => this.rowData = rowData); }

Afterwards, let's enable the enterprise features of ag-grid. Install the additional package:

npm install --save ag-grid-enterprise

Then, add the import to src/main.js:

import Vue from 'vue' +import 'ag-grid-enterprise'; import App from './App'

If everything is ok, you should see a message in the console that warns you about missing enterprise license. In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup - feel free to look around:

ag-Grid final

Now, let's enable grouping! Add an autoGroupColumnDef property, bind to it, and update the columnDefs with a rowGroup:

<template> <div> <button @click="getSelectedRows()">Get Selected Rows</button> <ag-grid-vue style="width: 500px; height: 500px;" class="ag-theme-balham" :columnDefs="columnDefs" :rowData="rowData" rowSelection="multiple" :gridReady="onGridReady"> </ag-grid-vue> </div> </template> <script> import {AgGridVue} from "ag-grid-vue"; export default { name: 'App', data() { return { columnDefs: null, rowData: null, gridApi: null, columnApi: null, autoGroupColumnDef: null } }, components: { AgGridVue }, methods: { onGridReady(params) { this.gridApi = params.api; this.columnApi = params.columnApi; }, getSelectedRows() { const selectedNodes = this.gridApi.getSelectedNodes(); const selectedData = selectedNodes.map(node => node.data); const selectedDataStringPresentation = selectedData.map(node => node.make + ' ' + node.model).join(', '); alert(`Selected nodes: ${selectedDataStringPresentation}`); } }, beforeMount() { this.columnDefs = [ {headerName: 'Make', field: 'make', rowGroup: true}, {headerName: 'Model', field: 'model'}, {headerName: 'Price', field: 'price'} ]; this.autoGroupColumnDef = { headerName: 'Model', field: 'model', cellRenderer: 'agGroupCellRenderer', cellRendererParams: { checkbox: true } }; fetch('https://api.myjson.com/bins/15psn9') .then(result => result.json()) .then(rowData => this.rowData = rowData); } } </script> <style> </style>

There we go! The grid now groups the data by make, while listing the model field value when expanded. Notice that grouping works with checkboxes as well - the groupSelectsChildren property adds a group-level checkbox that selects/deselects all items in the group.

Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.

Customize the Theme Look

The last thing which we are going to do is to change the grid look and feel by modifying some of the theme's Sass variables.

By default, ag-Grid ships a set of pre-built theme stylesheets. If we want to tweak the colors and the fonts of theme, we should add a Sass preprocessor to our project, override the theme variable values, and refer the ag-grid Sass files instead of the pre-built stylesheets so that the variable overrides are applied.

The vue cli did a lot of for us including providing support for Sass. Let's switch to using the provided ag-Grid SCSS files - replace the style block in src/App.vue with:

<style lang="scss"> $ag-icons-path: "~ag-grid-community/src/styles/icons/"; @import "~ag-grid-community/src/styles/ag-grid.scss"; @import "~ag-grid-community/src/styles/ag-theme-balham.scss"; </style>

Notice that we had to aid the Sass preprocessor a bit by setting the $ag-icons-path variable. This is a common gotcha with Sass, as external image paths are considered relative to the main file. In fact, by specifying the icons path, we also made our first theme override! We might change the entire theme icon set by changing the path in the variable to a directory containing our icon set.

Let's do something simpler, though. We can override the alternating row background color to grayish blue. Add the following line:

$ag-icons-path: "~ag-grid-community/src/styles/icons/"; +$odd-row-background-color: #CFD8DC;

If everything is configured correctly, the second row of the grid will get slightly darker. Congratulations! You now know now bend the grid look to your will - there are a few dozens more Sass variables that let you control the font family and size, border color, header background color and even the amount of spacing in the cells and columns. The full Sass variable list is available in the themes documentation section.

Summary

With this tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping! While doing so, we learned how to configure the grid, how to access its API object, and how to change the styling of the component.

That's just scratching the surface, though. The grid has a lot more features to offer; the abilities to customize cells and headers with custom components allow for almost infinite possible configurations.

Next Steps

You are hungry for more? Head over to the Vue guides section for more in-depth information about the Vue flavor of ag-Grid. To learn more about the features used in this tutorial, you can go through the following help articles:

Sorting Filtering Grouping Selection Customize Themes with Sass

Get started with ag-Grid React Grid component in your project

The "ag" part of ag-Grid stands for "agnostic". The internal ag-Grid engine is implemented in plain JavaScript[1] and has zero dependencies. ag-Grid supports React through a wrapper component. The React wrapper lets you use ag-Grid in your application like any other React component – you pass configuration through properties and handle events through callbacks. You can even use React components to customize the grid UI and cell contents / behavior.

In this article, we will walk you through the necessary steps to add ag-Grid to an existing React project, and configure some of the essential features of it. We will show you some of the fundamentals of the grid (passing properties, using the API, etc). As a bonus, we will also tweak the grid's visual appearance using Sass variables.

Add ag-Grid to Your Project

For the purposes of this tutorial, we are going to scaffold a react app with create-react-app. Don't worry if your project has a different configuration. ag-Grid and the React wrapper are distributed as NPM packages, which should work with any common React project module bundler setup. Let's follow the create-react-app instructions - run the following commands in your terminal:

npx create-react-app my-app cd my-app npm start
npx comes with npm 5.2+ and higher, see instructions for older npm versions

If everything goes well, npm start has started the web server and conveniently opened a browser pointing to localhost:3000.

As a next step, let's add the ag-Grid NPM packages. run the following command in my-app (you may need a new instance of the terminal):

npm install --save ag-grid-community ag-grid-react

After a few seconds of waiting, you should be good to go. Let's get to the actual coding! Open src/App.js in your favorite text editor and change its contents to the following:

import React, { Component } from 'react';
import logo from './logo.svg';
import './App.css';

import { AgGridReact } from 'ag-grid-react';
import 'ag-grid-community/dist/styles/ag-grid.css';
import 'ag-grid-community/dist/styles/ag-theme-balham.css';

class App extends Component {
    constructor(props) {
        super(props);

        this.state = {
            columnDefs: [
                {headerName: "Make", field: "make"},
                {headerName: "Model", field: "model"},
                {headerName: "Price", field: "price"}

            ],
            rowData: [
                {make: "Toyota", model: "Celica", price: 35000},
                {make: "Ford", model: "Mondeo", price: 32000},
                {make: "Porsche", model: "Boxter", price: 72000}
            ]
        }
    }

    render() {
        return (
                <div 
                  className="ag-theme-balham"
                  style={{ 
	                height: '500px', 
	                width: '600px' }} 
		            >
                    <AgGridReact
                        columnDefs={this.state.columnDefs}
                        rowData={this.state.rowData}>
                    </AgGridReact>
                </div>
            );
    }
}

export default App;

Done? If everything is correct, we should see a simple grid that looks like this:

ag-Grid in its simplest form

Let's go over the App.jsx changes we made:

import {AgGridReact} from 'ag-grid-react';
import 'ag-grid-community/dist/styles/ag-grid.css';
import 'ag-grid-community/dist/styles/ag-theme-balham.css';

The three lines above import the AgGridReact component, the grid "structure" stylesheet (ag-grid.css), and one of the available grid themes: (ag-theme-balham.css). The grid ships several different themes; pick one that matches your project design. You can customize it further with Sass variables, a technique which we will cover further down the road.

constructor(props) { super(props); this.state = { columnDefs: [ {headerName: "Make", field: "make"}, {headerName: "Model", field: "model"}, {headerName: "Price", field: "price"} ], rowData: [ {make: "Toyota", model: "Celica", price: 35000}, {make: "Ford", model: "Mondeo", price: 32000}, {make: "Porsche", model: "Boxter", price: 72000} ] } }

The code above presents two essential configuration properties of the grid - the column definitions (columnDefs) and the data (rowData). In our case, the column definitions contain three columns; each column entry specifies the header label and the data field to be displayed in the body of the table.

The actual data is defined in the rowData as an array of objects. Notice that the fields of the objects match the field values in the columnDefs configuration object.


    <div style={{ height: '150px', width: '600px' }} className="ag-theme-balham">
        <AgGridReact
            columnDefs={this.state.columnDefs}
            rowData={this.state.rowData}>
        </AgGridReact>
    </div>

Finally, the JSX code above describes a wrapper DIV element which sets the grid dimensions and specifies the grid's theme by setting the className to ag-theme-balham. As you may have already noticed, the CSS class matches the name of CSS file we imported earlier.

Inside the container, we place an AgGridReact component with the configuration objects (columnDefs and rowData) from the component's constructor passed as properties.

Enable Sorting And Filtering

So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the least/most expensive? Well, enabling sorting in ag-Grid is actually quite simple - all you need to do is set the sort property to the column definitions.

columnDefs: [ {headerName: "Make", field: "make", sortable=true }, {headerName: "Model", field: "model", sortable=true }, {headerName: "Price", field: "price", sortable=true } ]

After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.

Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) or rows, with many columns. In a data set like this filtering is your friend.

As with sorting, enabling filtering is as easy as setting the filter property:

columnDefs: [ {headerName: "Make", field: "make", sortable=true, filter=true }, {headerName: "Model", field: "model", sortable=true, filter=true }, {headerName: "Price", field: "price", sortable=true, filter=true } ]

With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with filtering UI which lets you choose the kind of filter and the text that you want to filter by.

ag-Grid sorting and filtering

Fetch Remote Data

Displaying hard-coded data in JavaScript is not going to get us very far. In the real world, most of the time, we are dealing with data that resides on a remote server. Thanks to React, implementing this is actually quite simple. Notice that the actual data fetching is performed outside of the grid component - We are using the HTML5 fetch API.

{headerName: "Price", field: "price"} - ], - rowData: [ - {make: "Toyota", model: "Celica", price: 35000}, - {make: "Ford", model: "Mondeo", price: 32000}, - {make: "Porsche", model: "Boxter", price: 72000} ] } } + componentDidMount() { + fetch('https://api.myjson.com/bins/15psn9') + .then(result => result.json()) + .then(rowData => this.setState({rowData})) + } + render() {

Here, we replaced the rowData assignment in the constructor with a data fetch from a remote service. The remote data is the same as the one we initially had, so you should not notice any actual changes to the grid.

Enable Selection

Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements! It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system. We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.

Fortunately, the above task is quite simple with ag-Grid. As you may have already guessed, it is just a matter of adding and changing couple of properties:

this.state = { columnDefs: [ - {headerName: "Make", field: "make"}, + {headerName: "Make", + field: "make", + checkboxSelection: true}, {headerName: "Model", field: "model"}, <AgGridReact + rowSelection="multiple"

Great! Now the first column contains a checkbox that, when clicked, selects the row. The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we need the following change:


<div style={{ height: '150px', width: '600px' }} className="ag-theme-balham">
+    <button onClick={this.onButtonClick}>Get selected rows</button>
+
		 <AgGridReact
+      onGridReady={ params => this.gridApi = params.api }

Afterwards, add the following event handler at the end of the component class:

onButtonClick = e => { const selectedNodes = this.gridApi.getSelectedNodes() const selectedData = selectedNodes.map( node => node.data ) const selectedDataStringPresentation = selectedData.map( node => node.make + ' ' + node.model).join(', ') alert(`Selected nodes: ${selectedDataStringPresentation}`) }

Well, we cheated a bit. Calling alert is not exactly a call to our backend. Hopefully you will forgive us this shortcut for the sake of keeping the article short and simple. Of course, you can substitute that bit with a real-world application logic after you are done with the tutorial.

What happened above? Several things:

  • onGridReady={ params => this.gridApi = params.api } obtained a reference to the ag-grid API instance;
  • We added a button with an event handler;
  • Inside the event handler, we accessed the grid api object reference to access the currently selected grid row nodes;
  • Afterwards, we extracted the row nodes' underlying data items and converted them to a string suitable to be presented to the user in an alert box.

Grouping (enterprise)

Grouping is a feature exclusive to the enterprise version of ag-Grid.

In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data. In our case, the data is not that much. Let's switch to a slightly larger data set:

componentDidMount() { - fetch('https://api.myjson.com/bins/15psn9') + fetch('https://api.myjson.com/bins/ly7d1') .then(result => result.json()) .then(rowData => this.setState({rowData})) }

Afterwards, let's enable the enterprise features of ag-grid. Install the additional package:

npm install --save ag-grid-enterprise Then, add the import to your file: import { AgGridReact } from 'ag-grid-react'; import 'ag-grid-community/dist/styles/ag-grid.css'; import 'ag-grid-community/dist/styles/ag-theme-balham.css'; + import 'ag-grid-enterprise';

If everything is ok, you should see a message in the console that warns you about missing enterprise license. In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup - feel free to look around:

ag-Grid final

Now, let's enable grouping! Change the state assignment to this:

this.state = { columnDefs: [ {headerName: "Make", field: "make", rowGroup: true }, {headerName: "Price", field: "price"} ], autoGroupColumnDef: { headerName: "Model", field: "model", cellRenderer:'agGroupCellRenderer', cellRendererParams: { checkbox: true } } }

Then, change the component definition to receive the autoGroupColumnDef property and the groupSelectsChildren:

columnDefs={this.state.columnDefs} + groupSelectsChildren={true} + autoGroupColumnDef={this.state.autoGroupColumnDef} rowData={this.state.rowData} >

There we go! The grid now groups the data by make, while listing the model field value when expanded. Notice that grouping works with checkboxes as well - the groupSelectsChildren property adds a group-level checkbox that selects/deselects all items in the group.

Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.

Customize the Theme Look

The last thing which we are going to do is to change the grid look and feel by modifying some of the theme's Sass variables.

By default, ag-Grid ships a set of pre-built theme stylesheets. If we want to tweak the colors and the fonts of theme, we should add a Sass preprocessor to our project, override the theme variable values, and refer the ag-grid Sass files instead of the pre-built stylesheets so that the variable overrides are applied.

Adding Sass Preprocessor to create-react-app is well documented - follow the steps outlined in the respective help section.

After you are done with the setup, assuming that you have renamed src/App.css to src/App.scss, you can replace its contents with this:

$ag-icons-path: "../node_modules/ag-grid-community/src/styles/icons/"; @import "../node_modules/ag-grid-community/src/styles/ag-grid.scss"; @import "../node_modules/ag-grid-community/src/styles/ag-theme-balham.scss";

To avoid importing the stylesheets twice, remove the imports from src/App.js:

import { AgGridReact } from 'ag-grid-react'; -import 'ag-grid-community/dist/styles/ag-grid.css'; -import 'ag-grid-community/dist/styles/ag-theme-balham.css';

Notice that we had to aid the Sass preprocessor a bit by setting the $ag-icons-path variable. This is a common gotcha with Sass, as external image paths are considered relative to the main file. In fact, by specifying the icons path, we also made our first theme override! We might change the entire theme icon set by changing the path in the variable to a directory containing our icon set.

Let's do something simpler, though. We can override the alternating row background color to grayish blue. Add the following line:

$ag-icons-path: "../node_modules/ag-grid-community/src/styles/icons/"; +$odd-row-background-color: #CFD8DC;

If everything is configured correctly, the second row of the grid will get slightly darker. Congratulations! You now know now bend the grid look to your will - there are a few dozens more Sass variables that let you control the font family and size, border color, header background color and even the amount of spacing in the cells and columns. The full Sass variable list is available in the themes documentation section.

Summary

With this tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping! While doing so, we learned how to configure the grid, how to access its API object, and how to change the styling of the component.

That's just scratching the surface, though. The grid has a lot more features to offer; the abilities to customize cells and headers with custom components allow for almost infinite possible configurations.

Next Steps

You are hungry for more? Head over to the React guides section for more in-depth information about the React flavor of ag-Grid. To learn more about the features used in this tutorial, you can go through the following help articles:

Sorting Filtering Grouping Selection Customize Themes with Sass

In addition to that, if you are using Redux, make sure to check out the Integrating ag-Grid with Redux guide.


Test our React Grid component



1 This is not exactly true. ag-Grid's core, as well as the framework wrappers are written in TypeScript. This provides nice strong typing and compile-time checks for our TypeScript users, while not giving the Babel/Vanilla users any disadvantage. ↩

Get Started with ag-Grid in Your Angular Project

The "ag" part of ag-Grid stands for "agnostic". The internal ag-Grid engine is implemented in TypeScript with zero dependencies. ag-Grid supports Angular through a wrapper component. The wrapper lets you use ag-Grid in your application like any other Angular component – you pass configuration through property bindings and handle events through event bindings. You can even use Angular components to customize the grid UI and cell contents / behavior.

In this article, we will walk you through the necessary steps to add ag-Grid to an existing Angular project, and configure some of the essential features of it. We will show you some of the fundamentals of the grid (passing properties, using the API, etc). As a bonus, we will also tweak the grid's visual appearance using Sass variables.

Add ag-Grid to Your Project

For the purposes of this tutorial, we are going to scaffold an Angular app with angular CLI. Don't worry if your project has a different configuration. ag-Grid and its Angular wrapper are distributed as NPM packages, which should work with any common Angular project module bundler setup. Let's follow the Angular CLI instructions - run the following in your terminal:

npm install -g @angular/cli ng new my-app --style scss --routing false cd my-app ng serve
We are passing --style scss to the app scaffolding command so that we may customize the grid theme look through Sass variables.

If everything goes well, ng serve has started the web server. You can open your app at localhost:4200.

As a next step, let's add the ag-Grid NPM packages. run the following command in my-app (you may need a new instance of the terminal):

npm install --save ag-grid-community ag-grid-angular npm install # in certain circumstances npm will perform an "auto prune". This step ensures all expected dependencies are present

After a few seconds of waiting, you should be good to go. Let's get to the actual coding! As a first step, let's add the ag-Grid Angular module to our app module (src/app.module.ts):

import { BrowserModule } from '@angular/platform-browser'; import { NgModule } from '@angular/core'; import { AppComponent } from './app.component'; import { AgGridModule } from 'ag-grid-angular'; @NgModule({ declarations: [AppComponent], imports: [BrowserModule, AgGridModule.withComponents([])], providers: [], bootstrap: [AppComponent] }) export class AppModule {}
The withComponents call is necessary for the grid to be able to use Angular components as cells / headers - you can ignore it for now.

The next step is to add the ag-Grid styles - import them in styles.scss:

@import "~ag-grid-community/dist/styles/ag-grid.css"; @import "~ag-grid-community/dist/styles/ag-theme-balham.css";

The code above imports the grid "structure" stylesheet (ag-grid.css), and one of the available grid themes: (ag-theme-balham.css). The grid ships several different themes; pick one that matches your project design. You can customize it further with Sass variables, a technique which we will cover further down the road.

Next, let's declare the basic grid configuration. Edit src/app.component.ts:

import { Component } from '@angular/core'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent { title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make' }, {headerName: 'Model', field: 'model' }, {headerName: 'Price', field: 'price'} ]; rowData = [ { make: 'Toyota', model: 'Celica', price: 35000 }, { make: 'Ford', model: 'Mondeo', price: 32000 }, { make: 'Porsche', model: 'Boxter', price: 72000 } ]; }

The code above presents two essential configuration properties of the grid - the column definitions (columnDefs) and the data (rowData). In our case, the column definitions contain three columns; each column entry specifies the header label and the data field to be displayed in the body of the table.

Finally, let's add the component definition to our template. Edit app/app.component.html and remove the scaffold code:

<ag-grid-angular style="width: 500px; height: 500px;" class="ag-theme-balham" [rowData]="rowData" [columnDefs]="columnDefs" > </ag-grid-angular>

This is the ag-grid component definition, with two property bindings - rowData and columnDefs. The component also accepts the standard DOM style and class. We have set the class to ag-theme-balham, which defines the grid theme. As you may have already noticed, the CSS class matches the name of CSS file we imported earlier.

If everything works as expected, you should see a simple grid like the one on the screenshot:

ag-Grid hello world

Enable Sorting And Filtering

So far, so good. But wouldn't it be nice to be able to sort the data to help us see which car is the least/most expensive? Well, enabling sorting in ag-Grid is actually quite simple - all you need to do is set the sortable property to each column you want to be able to sort by.

columnDefs = [ {headerName: 'Make', field: 'make', sortable: true}, {headerName: 'Model', field: 'model', sortable: true}, {headerName: 'Price', field: 'price', sortable: true} ];

After adding the property, you should be able to sort the grid by clicking on the column headers. Clicking on a header toggles through ascending, descending and no-sort.

Our application doesn't have too many rows, so it's fairly easy to find data. But it's easy to imagine how a real-world application may have hundreds (or even hundreds of thousands!) or rows, with many columns. In a data set like this filtering is your friend.

As with sorting, enabling filtering is as easy as setting the filter property:

columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true}, {headerName: 'Model', field: 'model', sortable: true, filter: true}, {headerName: 'Price', field: 'price', sortable: true, filter: true} ];

With this property set, the grid will display a small column menu icon when you hover the header. Pressing it will display a popup with filtering UI which lets you choose the kind of filter and the text that you want to filter by.

ag-Grid sorting and filtering

Fetch Remote Data

Displaying hard-coded data in JavaScript is not going to get us very far. In the real world, most of the time, we are dealing with data that resides on a remote server. Thanks to Angular, implementing this is actually quite simple. Notice that the actual data fetching is performed outside of the grid component - We are using Angular's HttpClient and an async pipe. As a first step, let's add the HttpModule to our app module:

import { BrowserModule } from '@angular/platform-browser'; import { NgModule } from '@angular/core'; import { AppComponent } from './app.component'; import { AgGridModule } from 'ag-grid-angular'; import { HttpClientModule } from '@angular/common/http'; @NgModule({ declarations: [AppComponent], imports: [BrowserModule, HttpClientModule, AgGridModule.withComponents([])], providers: [], bootstrap: [AppComponent] }) export class AppModule {}

Now, let's remove the hard-coded data and fetch one from a remote server. Edit the src/app.component.ts to this:

import { Component, OnInit } from '@angular/core'; import { HttpClient } from '@angular/common/http'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent implements OnInit { title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true}, {headerName: 'Model', field: 'model', sortable: true, filter: true}, {headerName: 'Price', field: 'price', sortable: true, filter: true} ]; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://api.myjson.com/bins/15psn9'); } }

The above code turns the rowData from a hard-coded array to an Observable. For the grid to work with it, we need to add an async pipe to the property:

<ag-grid-angular style="width: 500px; height: 500px;" class="ag-theme-balham" [rowData]="rowData | async" [columnDefs]="columnDefs" > </ag-grid-angular>

The remote data is the same as the one we initially had, so you should not notice any actual changes to the grid. However, you will see an additional HTTP request performed if you open your developer tools.

Enable Selection

Being a programmer is a hectic job. Just when we thought that we are done with our assignment, the manager shows up with a fresh set of requirements! It turned out that we need to allow the user to select certain rows from the grid and to mark them as flagged in the system. We will leave the flag toggle state and persistence to the backend team. On our side, we should enable the selection and, afterwards, to obtain the selected records and pass them with an API call to a remote service endpoint.

Fortunately, the above task is quite simple with ag-Grid. As you may have already guessed, it is just a matter of adding and changing couple of properties. Edit src/app.component.ts first:

import { Component, OnInit, ViewChild } from '@angular/core'; import { HttpClient } from '@angular/common/http'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent implements OnInit { title = 'app'; columnDefs = [ {headerName: 'make', field: 'make', sortable: true, filter: true, checkboxSelection: true }, {headerName: 'model', field: 'model', sortable: true, filter: true }, {headerName: 'price', field: 'price', sortable: true, filter: true } ]; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://api.myjson.com/bins/15psn9'); } }

Next, let's enable multiple row selection, so that the user can pick many rows:

<ag-grid-angular style="width: 500px; height: 500px;" class="ag-theme-balham" [rowData]="rowData | async" [columnDefs]="columnDefs" rowSelection="multiple" > </ag-grid-angular>
We took a bit of a shortcut here, by not binding the property value. Without [], the assignment will pass the attribute value as a string, which is fine for our purposes.

Great! Now the first column contains a checkbox that, when clicked, selects the row. The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we are going to use the ag-Grid API - we will access it through the component instance.

<ag-grid-angular #agGrid style="width: 500px; height: 500px;" class="ag-theme-balham" [rowData]="rowData | async" [columnDefs]="columnDefs" rowSelection="multiple" > </ag-grid-angular>

Now let's make the instance accessible in our component:

import { Component, OnInit, ViewChild } from '@angular/core'; import { HttpClient } from '@angular/common/http'; import { AgGridNg2 } from 'ag-grid-angular'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent implements OnInit { @ViewChild('agGrid') agGrid: AgGridNg2; title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true, checkboxSelection: true }, {headerName: 'Model', field: 'model', sortable: true, filter: true }, {headerName: 'Price', field: 'price', sortable: true, filter: true } ]; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://api.myjson.com/bins/15psn9'); } }

The only thing we have to add is a button that gets the selected data and sends it to the server. To do this, we need the following change:

<button (click)="getSelectedRows()">Get Selected Rows</button> <ag-grid-angular #agGrid style="width: 500px; height: 500px;" class="ag-theme-balham" [rowData]="rowData | async" [columnDefs]="columnDefs" rowSelection="multiple" > </ag-grid-angular> import { Component, OnInit, ViewChild } from '@angular/core'; import { HttpClient } from '@angular/common/http'; import { AgGridNg2 } from 'ag-grid-angular'; @Component({ selector: 'app-root', templateUrl: './app.component.html', styleUrls: ['./app.component.scss'] }) export class AppComponent implements OnInit { @ViewChild('agGrid') agGrid: AgGridNg2; title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make', sortable: true, filter: true, checkboxSelection: true }, {headerName: 'Model', field: 'model', sortable: true, filter: true }, {headerName: 'Price', field: 'price', sortable: true, filter: true } ]; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://api.myjson.com/bins/15psn9'); } getSelectedRows() { const selectedNodes = this.agGrid.api.getSelectedNodes(); const selectedData = selectedNodes.map( node => node.data ); const selectedDataStringPresentation = selectedData.map( node => node.make + ' ' + node.model).join(', '); alert(`Selected nodes: ${selectedDataStringPresentation}`); } }

Well, we cheated a bit. Calling alert is not exactly a call to our backend. Hopefully you will forgive us this shortcut for the sake of keeping the article short and simple. Of course, you can substitute that bit with a real-world application logic after you are done with the tutorial.

Grouping (Enterprise)

Grouping is a feature exclusive to the enterprise version of ag-Grid.

In addition to filtering and sorting, grouping is another effective way for the user to make sense out of large amounts of data. In our case, the data is not that much. Let's switch to a slightly larger data set:

ngOnInit() { - this.rowData = this.http.get('https://api.myjson.com/bins/15psn9'); + this.rowData = this.http.get('https://api.myjson.com/bins/ly7d1'); }

Afterwards, let's enable the enterprise features of ag-grid. Install the additional package:

npm install --save ag-grid-enterprise

Then, add the import to app.module.ts:

import { AgGridModule } from 'ag-grid-angular'; import { HttpClientModule } from '@angular/common/http'; +import 'ag-grid-enterprise';

If everything is ok, you should see a message in the console that warns you about missing enterprise license. In addition to that, the grid got a few UI improvements - a custom context menu and fancier column menu popup - feel free to look around:

ag-Grid final

Now, let's enable grouping! Add an autoGroupColumnDef property and change the columnDefs to the following:

export class AppComponent implements OnInit { @ViewChild('agGrid') agGrid: AgGridNg2; title = 'app'; columnDefs = [ {headerName: 'Make', field: 'make', rowGroup: true }, {headerName: 'Price', field: 'price'} ]; autoGroupColumnDef = { headerName: 'Model', field: 'model', cellRenderer: 'agGroupCellRenderer', cellRendererParams: { checkbox: true } }; rowData: any; constructor(private http: HttpClient) { } ngOnInit() { this.rowData = this.http.get('https://api.myjson.com/bins/ly7d1'); } getSelectedRows() { const selectedNodes = this.agGrid.api.getSelectedNodes(); const selectedData = selectedNodes.map( node =< node.data ); const selectedDataStringPresentation = selectedData.map( node =< node.make + ' ' + node.model).join(', '); alert(`Selected nodes: ${selectedDataStringPresentation}`); } }

Add the the autoGroupColumnDef property to the template too:

class="ag-theme-balham" +[autoGroupColumnDef]="autoGroupColumnDef"

There we go! The grid now groups the data by make, while listing the model field value when expanded. Notice that grouping works with checkboxes as well - the groupSelectsChildren property adds a group-level checkbox that selects/deselects all items in the group.

Don't worry if this step feels a bit overwhelming - the grouping feature is very powerful and supports complex interaction scenarios which you might not need initially. The grouping documentation section contains plenty of real-world runnable examples that can get you started for your particular case.

Customize the Theme Look

The last thing which we are going to do is to change the grid look and feel by modifying some of the theme's Sass variables.

By default, ag-Grid ships a set of pre-built theme stylesheets. If we want to tweak the colors and the fonts of theme, we should add a Sass preprocessor to our project, override the theme variable values, and refer the ag-grid Sass files instead of the pre-built stylesheets so that the variable overrides are applied.

Thankfully, Angular CLI has done most of the heavy lifting for us. Remember that we bootstrapped our project with --style scss? Everything we need to do now is to change the paths in src/styles.scss:

$ag-icons-path: "../node_modules/ag-grid/src/styles/icons/"; @import "~ag-grid-community/src/styles/ag-grid.scss"; @import "~ag-grid-community/src/styles/ag-theme-balham.scss";

Notice that we had to aid the Sass preprocessor a bit by setting the $ag-icons-path variable. This is a common gotcha with Sass, as external image paths are considered relative to the main file. In fact, by specifying the icons path, we also made our first theme override! We might change the entire theme icon set by changing the path in the variable to a directory containing our icon set.

Let's do something simpler, though. We can override the alternating row background color to grayish blue. Add the following line:

$ag-icons-path: "../node_modules/ag-grid-community/src/styles/icons/"; +$odd-row-background-color: #CFD8DC;

If everything is configured correctly, the second row of the grid will get slightly darker. Congratulations! You now know now bend the grid look to your will - there are a few dozens more Sass variables that let you control the font family and size, border color, header background color and even the amount of spacing in the cells and columns. The full Sass variable list is available in the themes documentation section.

Summary

With this Angular grid tutorial, we managed to accomplish a lot. Starting from the humble beginnings of a three row / column setup, we now have a grid that supports sorting, filtering, binding to remote data, selection and even grouping! While doing so, we learned how to configure the grid, how to access its API object, and how to change the styling of the component.

That's just scratching the surface, though. The grid has a lot more features to offer; the abilities to customize cells and headers with custom components allow for almost infinite possible configurations.

Next Steps

You are hungry for more? Head over to the Angular guides section for more in-depth information about the Angular flavor of ag-Grid. To learn more about the features used in this tutorial, you can go through the following help articles:

Sorting Filtering Grouping Selection Customize Themes with Sass